net: Add socket() system call self test.
David S. Miller [Tue, 19 Mar 2013 18:49:44 +0000 (14:49 -0400)]
Signed-off-by: David S. Miller <davem@davemloft.net>

tools/testing/selftests/Makefile
tools/testing/selftests/net-socket/Makefile [new file with mode: 0644]
tools/testing/selftests/net-socket/run_netsocktests [new file with mode: 0644]
tools/testing/selftests/net-socket/socket.c [new file with mode: 0644]

index 3cc0ad7..7c6280f 100644 (file)
@@ -5,6 +5,7 @@ TARGETS += vm
 TARGETS += cpu-hotplug
 TARGETS += memory-hotplug
 TARGETS += efivarfs
+TARGETS += net-socket
 
 all:
        for TARGET in $(TARGETS); do \
diff --git a/tools/testing/selftests/net-socket/Makefile b/tools/testing/selftests/net-socket/Makefile
new file mode 100644 (file)
index 0000000..f27ee10
--- /dev/null
@@ -0,0 +1,16 @@
+# Makefile for net-socket selftests
+
+CC = $(CROSS_COMPILE)gcc
+CFLAGS = -Wall
+
+NET_SOCK_PROGS = socket
+
+all: $(NET_SOCK_PROGS)
+%: %.c
+       $(CC) $(CFLAGS) -o $@ $^
+
+run_tests: all
+       @/bin/sh ./run_netsocktests || echo "vmtests: [FAIL]"
+
+clean:
+       $(RM) $(NET_SOCK_PROGS)
diff --git a/tools/testing/selftests/net-socket/run_netsocktests b/tools/testing/selftests/net-socket/run_netsocktests
new file mode 100644 (file)
index 0000000..c09a682
--- /dev/null
@@ -0,0 +1,12 @@
+#!/bin/bash
+
+echo "--------------------"
+echo "running socket test"
+echo "--------------------"
+./socket
+if [ $? -ne 0 ]; then
+       echo "[FAIL]"
+else
+       echo "[PASS]"
+fi
+
diff --git a/tools/testing/selftests/net-socket/socket.c b/tools/testing/selftests/net-socket/socket.c
new file mode 100644 (file)
index 0000000..0f227f2
--- /dev/null
@@ -0,0 +1,92 @@
+#include <stdio.h>
+#include <errno.h>
+#include <unistd.h>
+#include <string.h>
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+
+struct socket_testcase {
+       int     domain;
+       int     type;
+       int     protocol;
+
+       /* 0    = valid file descriptor
+        * -foo = error foo
+        */
+       int     expect;
+
+       /* If non-zero, accept EAFNOSUPPORT to handle the case
+        * of the protocol not being configured into the kernel.
+        */
+       int     nosupport_ok;
+};
+
+static struct socket_testcase tests[] = {
+       { AF_MAX,  0,           0,           -EAFNOSUPPORT,    0 },
+       { AF_INET, SOCK_STREAM, IPPROTO_TCP, 0,                1  },
+       { AF_INET, SOCK_DGRAM,  IPPROTO_TCP, -EPROTONOSUPPORT, 1  },
+       { AF_INET, SOCK_DGRAM,  IPPROTO_UDP, 0,                1  },
+       { AF_INET, SOCK_STREAM, IPPROTO_UDP, -EPROTONOSUPPORT, 1  },
+};
+
+#define ARRAY_SIZE(arr) (sizeof(arr) / sizeof((arr)[0]))
+#define ERR_STRING_SZ  64
+
+static int run_tests(void)
+{
+       char err_string1[ERR_STRING_SZ];
+       char err_string2[ERR_STRING_SZ];
+       int i, err;
+
+       err = 0;
+       for (i = 0; i < ARRAY_SIZE(tests); i++) {
+               struct socket_testcase *s = &tests[i];
+               int fd;
+
+               fd = socket(s->domain, s->type, s->protocol);
+               if (fd < 0) {
+                       if (s->nosupport_ok &&
+                           errno == EAFNOSUPPORT)
+                               continue;
+
+                       if (s->expect < 0 &&
+                           errno == -s->expect)
+                               continue;
+
+                       strerror_r(-s->expect, err_string1, ERR_STRING_SZ);
+                       strerror_r(errno, err_string2, ERR_STRING_SZ);
+
+                       fprintf(stderr, "socket(%d, %d, %d) expected "
+                               "err (%s) got (%s)\n",
+                               s->domain, s->type, s->protocol,
+                               err_string1, err_string2);
+
+                       err = -1;
+                       break;
+               } else {
+                       close(fd);
+
+                       if (s->expect < 0) {
+                               strerror_r(errno, err_string1, ERR_STRING_SZ);
+
+                               fprintf(stderr, "socket(%d, %d, %d) expected "
+                                       "success got err (%s)\n",
+                                       s->domain, s->type, s->protocol,
+                                       err_string1);
+
+                               err = -1;
+                               break;
+                       }
+               }
+       }
+
+       return err;
+}
+
+int main(void)
+{
+       int err = run_tests();
+
+       return err;
+}